<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8"/>
<title>How to write new tests for openQA</title>
<meta name="author" content="Philip Hands"/>
<style type="text/css">
.underline { text-decoration: underline; }
</style>
<link rel="stylesheet" href="file:///home/phil/.emacs.doom/.local/straight/build-29.4/revealjs/dist/reveal.css"/>

<link rel="stylesheet" href="file:///home/phil/.emacs.doom/.local/straight/build-29.4/revealjs/dist/theme/moon.css" id="theme"/>
<meta name="description" content="openqa Debian Hamburg Reunion 2022 presentation">
</head>
<body>
<div class="reveal">
<div class="slides">
<section id="sec-title-slide">
<h1 class="title">How to write new tests for openQA</h1><h2 class="author">Philip Hands</h2><p class="date">Created: 2024-10-09 Wed 20:55</p>
</section>
<section>
<section id="slide-org41d28bd">
<h2 id="org41d28bd">What is openQA?</h2>
<p>
A thing for running tests on whole systems, by <i>looking</i> at the screen, and reacting to what it <i>sees</i> in various ways.
</p>

<div style="font-size: 80%;">
<p>
<a href="https://debconf21.debconf.org/talks/31-openqadebiannet-automated-testing-of-debian-installer-and-beyond">https://debconf21.debconf.org/talks/31-openqadebiannet-automated-testing-of-debian-installer-and-beyond</a>
</p>
</div>
</section>
</section>
<section>
<section id="slide-org90073f7">
<h2 id="org90073f7">Getting started</h2>
<ul>
<li>Install <b>openQA</b> locally
<ul>
<li><p>
Directly on your system:
</p>
<pre class="example">
apt install openqa openqa-worker
</pre>

<p>
(currently needs things from <b>sid</b>)
</p></li>

<li><p>
in a VM:
</p>

<p>
Roland&rsquo;s blog: <a href="https://rclobus.nl/blog/?p=267">https://rclobus.nl/blog/?p=267</a>
</p></li>

</ul></li>

</ul>
</section>
</section>
<section>
<section id="slide-orgbd6512e">
<h2 id="orgbd6512e">Shared test area</h2>
<ul>
<li>writable for you and openQA&rsquo;s <span class="underline">geekotest</span> user</li>
<li>openQA is unwilling to follow sym-links</li>
<li>I use a bind-mount, and keep the tests under home</li>
<li>I create a <span class="underline">geekotest</span> group and give it write access.</li>

</ul>

<p>
This is a work in progress &#x2013; I&rsquo;m interested to know how others go about it.
</p>
</section>
</section>
<section>
<section id="slide-org8d2c53d">
<h2 id="org8d2c53d">Writing a test</h2>
<ul>
<li>clone the test repo (after forking it on salsa)
<a href="https://salsa.debian.org/qa/openqa/openqa-tests-debian/">salsa.debian.org/qa/openqa/openqa-tests-debian</a></li>
<li><p>
find a similar test.  e.g.:
</p>
<pre class="example">
tests/desktop_printing.pm
</pre></li>

</ul>
</section>
<section id="slide-org88e503d">
<h3 id="org88e503d">Our new test:</h3>
<div style="font-size: 50%;">
<div class="org-src-container">

<pre class="src src-perl"><span style="color: #20b2aa; font-weight: bold;">use</span> <span style="color: #00ff7f;">base</span> <span style="color: #ffa07a;">"installedtest"</span>;
<span style="color: #20b2aa; font-weight: bold;">use</span> <span style="color: #00ff7f;">strict</span>;
<span style="color: #20b2aa; font-weight: bold;">use</span> <span style="color: #00ff7f;">testapi</span>;
<span style="color: #20b2aa; font-weight: bold;">use</span> <span style="color: #00ff7f;">utils</span>;

<span style="color: #20b2aa; font-weight: bold;">sub</span> <span style="color: #00ff7f;">run</span> {
    <span style="color: #20b2aa; font-weight: bold;">my</span> <span style="color: #9acd32;">$self</span> = <span style="color: #ff83fa;">shift</span>;

    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">throw a delay in, to ensure that we've a settled state in the desktop</span>
    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">before switching away from it, in the hope that lets us get back here</span>
    wait_still_screen(<span style="color: #ffa07a;">stilltime</span>=&gt;<span style="color: #1e90ff;">5</span>, <span style="color: #ffa07a;">similarity_level</span>=&gt;<span style="color: #1e90ff;">45</span>);

    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">Prepare the environment:</span>
    <span style="color: #cd853f;">#</span>
    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">Become root</span>
    <span style="color: #9acd32;">$self</span>-&gt;root_console(<span style="color: #ffa07a;">tty</span>=&gt;<span style="color: #1e90ff;">3</span>);
    console_loadkeys_us;

    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">make sure emacs is installed</span>
    assert_script_run <span style="color: #ffa07a;">"apt install -y emacs"</span>, <span style="color: #1e90ff;">180</span>;
    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">Leave the root terminal and switch back to desktop.</span>
    desktop_vt();

    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">Run emacs via Alt-F2</span>
    wait_screen_change { send_key <span style="color: #ffa07a;">"alt-f2"</span>; };
    wait_still_screen(<span style="color: #ffa07a;">stilltime</span>=&gt;<span style="color: #1e90ff;">5</span>, <span style="color: #ffa07a;">similarity_level</span>=&gt;<span style="color: #1e90ff;">45</span>);

    type_very_safely <span style="color: #ffa07a;">"emacs\n"</span>;
    wait_still_screen(<span style="color: #ffa07a;">stilltime</span>=&gt;<span style="color: #1e90ff;">5</span>, <span style="color: #ffa07a;">similarity_level</span>=&gt;<span style="color: #1e90ff;">44</span>);
    <span style="color: #20b2aa; font-weight: bold;">if</span> (check_screen <span style="color: #ffa07a;">"console_instead_of_GUI"</span>, <span style="color: #1e90ff;">1</span>) {
        <span style="color: #20b2aa; font-weight: bold;">die</span> <span style="color: #ffa07a;">"failed to switch back to GUI"</span>;
    }

    assert_screen <span style="color: #ffa07a;">"emacs_splashscreen"</span>;
    send_key <span style="color: #ffa07a;">"alt-x"</span>;
    type_safely <span style="color: #ffa07a;">"hanoi\n"</span>;
    assert_screen <span style="color: #ffa07a;">"emacs_hanoi_solved"</span>;
}


<span style="color: #20b2aa; font-weight: bold;">sub</span> <span style="color: #00ff7f;">test_flags</span> {
    <span style="color: #20b2aa; font-weight: bold;">return</span> { <span style="color: #ffa07a;">fatal</span> =&gt; <span style="color: #1e90ff;">1</span> };
}

<span style="color: #1e90ff;">1</span>;
</pre>
</div>
</div>
</section>
<section id="slide-org61d7846">
<h3 id="org61d7846">standard intro</h3>
<div class="org-src-container">

<pre class="src src-perl"><span style="color: #20b2aa; font-weight: bold;">use</span> <span style="color: #00ff7f;">base</span> <span style="color: #ffa07a;">"installedtest"</span>;
<span style="color: #20b2aa; font-weight: bold;">use</span> <span style="color: #00ff7f;">strict</span>;
<span style="color: #20b2aa; font-weight: bold;">use</span> <span style="color: #00ff7f;">testapi</span>;
<span style="color: #20b2aa; font-weight: bold;">use</span> <span style="color: #00ff7f;">utils</span>;

<span style="color: #20b2aa; font-weight: bold;">sub</span> <span style="color: #00ff7f;">run</span> {
    <span style="color: #20b2aa; font-weight: bold;">my</span> <span style="color: #9acd32;">$self</span> = <span style="color: #ff83fa;">shift</span>;

    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">throw a delay in, to ensure that we've a settled state in the desktop</span>
    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">before switching away from it, in the hope that lets us get back here</span>
    wait_still_screen(<span style="color: #ffa07a;">stilltime</span>=&gt;<span style="color: #1e90ff;">5</span>, <span style="color: #ffa07a;">similarity_level</span>=&gt;<span style="color: #1e90ff;">45</span>);
</pre>
</div>
</section>
<section id="slide-org2d283c7">
<h3 id="org2d283c7">prepare test environment (install emacs)</h3>
<div class="org-src-container">

<pre class="src src-perl">    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">Prepare the environment:</span>
    <span style="color: #cd853f;">#</span>
    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">Become root</span>
    <span style="color: #9acd32;">$self</span>-&gt;root_console(<span style="color: #ffa07a;">tty</span>=&gt;<span style="color: #1e90ff;">3</span>);
    console_loadkeys_us;

    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">make sure emacs is installed</span>
    assert_script_run <span style="color: #ffa07a;">"apt install -y emacs"</span>, <span style="color: #1e90ff;">180</span>;
    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">Leave the root terminal and switch back to desktop.</span>
    desktop_vt();
</pre>
</div>
</section>
<section id="slide-org81cdd27">
<h3 id="org81cdd27">start the test (run emacs)</h3>
<div class="org-src-container">

<pre class="src src-perl">    <span style="color: #cd853f;"># </span><span style="color: #cd853f;">Run emacs via Alt-F2</span>
    wait_screen_change { send_key <span style="color: #ffa07a;">"alt-f2"</span>; };
    wait_still_screen(<span style="color: #ffa07a;">stilltime</span>=&gt;<span style="color: #1e90ff;">5</span>, <span style="color: #ffa07a;">similarity_level</span>=&gt;<span style="color: #1e90ff;">45</span>);

    type_very_safely <span style="color: #ffa07a;">"emacs\n"</span>;
</pre>
</div>
</section>
<section id="slide-org436f3a3">
<h3 id="org436f3a3">a little inherited paranoia</h3>
<div class="org-src-container">

<pre class="src src-perl">    wait_still_screen(<span style="color: #ffa07a;">stilltime</span>=&gt;<span style="color: #1e90ff;">5</span>, <span style="color: #ffa07a;">similarity_level</span>=&gt;<span style="color: #1e90ff;">44</span>);
    <span style="color: #20b2aa; font-weight: bold;">if</span> (check_screen <span style="color: #ffa07a;">"console_instead_of_GUI"</span>, <span style="color: #1e90ff;">1</span>) {
        <span style="color: #20b2aa; font-weight: bold;">die</span> <span style="color: #ffa07a;">"failed to switch back to GUI"</span>;
    }
</pre>
</div>
</section>
<section id="slide-org172d37a">
<h3 id="org172d37a">check things look OK</h3>
<div class="org-src-container">

<pre class="src src-perl">    assert_screen <span style="color: #ffa07a;">"emacs_splashscreen"</span>;
    send_key <span style="color: #ffa07a;">"alt-x"</span>;
    type_safely <span style="color: #ffa07a;">"hanoi\n"</span>;
    assert_screen <span style="color: #ffa07a;">"emacs_hanoi_solved"</span>;
</pre>
</div>
</section>
<section id="slide-org8a8fffc">
<h3 id="org8a8fffc">standard outro</h3>
<div class="org-src-container">

<pre class="src src-perl">}

<span style="color: #20b2aa; font-weight: bold;">sub</span> <span style="color: #00ff7f;">test_flags</span> {
    <span style="color: #20b2aa; font-weight: bold;">return</span> { <span style="color: #ffa07a;">fatal</span> =&gt; <span style="color: #1e90ff;">1</span> };
}

<span style="color: #1e90ff;">1</span>;
</pre>
</div>
</section>
</section>
<section>
<section id="slide-org330dd0b">
<h2 id="org330dd0b">Running the test</h2>
<ul>
<li><p>
clone one of the <i>parent</i> test&rsquo;s jobs:
</p>
<pre class="example">
openqa-clone-job --skip-deps \
   https://openqa.debian.net/tests/57274 \
   POSTINSTALL=desktop_emacs
</pre></li>
<li>use <i>Developer Mode</i> to create new <i>Needles</i></li>
<li><p>
or let the test fail, and add missing <i>Needles</i> later
</p>

<p>
<a href="http://localhost/tests/41816">http://localhost/tests/41816</a>
</p></li>
<li>repeat required steps until it works
<a href="http://localhost/tests/41812">http://localhost/tests/41812</a></li>

</ul>
</section>
</section>
<section>
<section id="slide-org5c2d71d">
<h2 id="org5c2d71d">Contributing the test to run on openqa.debian.net</h2>
<ul>
<li>add your test into the <a href="https://salsa.debian.org/qa/openqa/openqa-tests-debian/-/commit/79bfaa882a543e0a827c9aa5b560b5b1109ff366#e22f359175909a38de98fa1cf5ac9e0ce83a9ad1">templates.fif.json</a> file</li>
<li>push your changes to your salsa fork and open a Merge Request</li>

</ul>
</section>
</section>
<section>
<section id="slide-org6dab3c2">
<h2 id="org6dab3c2">Questions and Answers</h2>
<div style="font-size: 85%;">
<ul>
<li><a href="https://salsa.debian.org/qa/openqa/openqa-tests-debian/">https://salsa.debian.org/qa/openqa/openqa-tests-debian/</a></li>
<li><a href="https://openqa.debian.net/">https://openqa.debian.net/</a></li>
<li><a href="https://open.qa/docs/#writingtests">https://open.qa/docs/#writingtests</a></li>

</ul>
</div>

<p>
<code>Email: phil@hands.com ─ IRC: fil</code>
</p>
</section>
</section>
</div>
</div>
<p> Created by Philip Hands. </p>
<script src="file:///home/phil/.emacs.doom/.local/straight/build-29.4/revealjs/dist/reveal.js"></script>
<script src="file:///home/phil/.emacs.doom/.local/straight/build-29.4/revealjs/plugin/markdown/markdown.js"></script>
<script src="file:///home/phil/.emacs.doom/.local/straight/build-29.4/revealjs/plugin/notes/notes.js"></script>
<script src="file:///home/phil/.emacs.doom/.local/straight/build-29.4/revealjs/plugin/search/search.js"></script>
<script src="file:///home/phil/.emacs.doom/.local/straight/build-29.4/revealjs/plugin/zoom/zoom.js"></script>
<script>
// Full list of configuration options available here:
// https://github.com/hakimel/reveal.js#configuration
Reveal.initialize({

controls: true,
progress: true,
history: false,
center: true,
slideNumber: 'c',
rollingLinks: false,
keyboard: true,
mouseWheel: false,
fragmentInURL: false,
hashOneBasedIndex: false,
pdfSeparateFragments: true,
overview: true,

transition: 'convex',
transitionSpeed: 'default',

// Plugins with reveal.js 4.x
plugins: [ RevealMarkdown, RevealNotes, RevealSearch, RevealZoom ],

// Optional libraries used to extend reveal.js
dependencies: [
]

});
</script>
</body>
</html>
